import { Reviver, PresetTypeReviverMap } from "./customJSON";
import { TypeReviverMap, TypeRevivers } from "type-reviver";
export interface TypeReviversPair {
    string?: TypeRevivers<Reviver>;
    parse?: TypeRevivers<Reviver>;
}
/**
 * StringParseTypeRevivers 的类型守卫
 * @param target
 */
export declare function isTypeReviversPair(target: any): target is TypeReviversPair;
export declare type TypeReviversOptions = TypeRevivers<Reviver> | TypeReviversPair;
export interface DeepCopyByJSON extends PresetTypeReviverMap {
    <T>(value: T, typeReviversOpts?: TypeReviversOptions | null): T;
}
/**
 * 创建带 presetTypeReviverMap 的 deepCopyByJSON 的工厂函数
 * @param presetTypeReviverMap
 */
export declare function createDeepCopyByJSONWith(presetTypeReviverMap?: TypeReviverMap<Reviver>): DeepCopyByJSON;
/**
 * 通过 自定义 JSON 序列人的方式 对 value 进行 深拷贝
 */
export declare const deepCopyByJSON: DeepCopyByJSON;
